local LDB = LibStub("LibDataBroker-1.1", true)
local LDBIcon = LDB and LibStub("LibDBIcon-1.0", true)
local L = LibStub("AceLocale-3.0"):GetLocale("ENStats")

function ENStats:PLAYER_LOGIN()
	self:UnregisterEvent("PLAYER_LOGIN")

	if LDB and not IsAddOnLoaded("FuBar") then
		ENStatsLauncher = LDB:NewDataObject("Endeavour's Noob Stats", {
			type = "launcher",
			icon = "Interface\\Icons\\Ability_Hunter_MasterMarksman",
			OnClick = function(clickedframe, button)
				ENStats:OnFuBarClick(button)
			end,
			OnTooltipShow = function(tt)
				ENStats:OnUpdateFuBarTooltip()
			end,
		})
		if LDBIcon then
			LDBIcon:Register("Endeavour's Noob Stats", ENStatsLauncher, dbd.MiniMap)
			function ENStats:ToggleMM(value)
				if value then LDBIcon:Show("Endeavour's Noob Stats") else LDBIcon:Hide("Endeavour's Noob Stats") end
				LDBIcon:Refresh("Endeavour's Noob Stats", ENStats.db.global.MiniMap)
			end
		end		
	end
	
	if LibStub:GetLibrary("LibFuBarPlugin-3.0", true) and IsAddOnLoaded("FuBar") then
		local LFBP = LibStub:GetLibrary("LibFuBarPlugin-3.0")
		LibStub("AceAddon-3.0"):EmbedLibrary(self, "LibFuBarPlugin-3.0")
		ENStats:SetFuBarOption('tooltipType', "GameTooltip")
		ENStats:SetFuBarOption('iconPath', "Interface\\Icons\\Ability_Hunter_MasterMarksman")
		ENStats:SetFuBarOption('hasIcon', true)
		ENStats:SetFuBarOption('configType', "None")
		ENStats:SetFuBarOption("defaultMinimapPosition" , 195)	
		LFBP:OnEmbedInitialize(self)	
		ENStats:SetFuBarText("Endeavour's Noob Stats")	
		ENStats:Show()
	end
end

function ENStats:OnUpdateFuBarTooltip()
	GameTooltip:AddLine("|cffff8800Endeavour's Noob Stats|r".." |cff7fff7fv"..ENStats.version.."|r");
	GameTooltip:AddLine("|cffA843EFby Yvaine/Endeavour EU Arthas|r")
	GameTooltip:AddLine(" ")
	GameTooltip:AddLine(L["|cff7fff7fleftclick:|r toggle window"])
	GameTooltip:AddLine(L["|cff7fff7frightclick:|r show options menu"])
	GameTooltip:AddLine(" ")
end

function ENStats:OnFuBarClick(button)
	if button == "LeftButton" then 
		if ENStats.header:IsVisible() then 
			ENStats.MainFrame:Hide()
		else
			ENStats.MainFrame:Show()
		end
	elseif button =="RightButton" then
		InterfaceOptionsFrame_OpenToCategory("Endeavour's Noob Stats")
	end   	
end