LoadAddOn("Ace3")
LoadAddOn("LibDataBroker-1.1")
LoadAddOn("LibSharedMedia-3.0")
LoadAddOn("SharedMedia")
LoadAddOn("LibDBIcon-1.0")
LoadAddOn("LibFuBarPlugin-3.0")

ENStats = LibStub("AceAddon-3.0"):NewAddon("ENStats", "AceConsole-3.0", "AceEvent-3.0") 
local L = LibStub("AceLocale-3.0"):GetLocale("ENStats")
local media = LibStub("LibSharedMedia-3.0")
local textures = media:List("statusbar")
local fonts = media:List("font")

local function GetLSMIndex(t, value)
	for k, v in pairs(media:List(t)) do
		if v == value then
			return k
		end
	end
	return nil
end

ENStats.options = { 
	type = "group", 
	name = "Endeavour's Noob Stats", 
	args = {
		general = {
			type = "group",
			inline = true,
			name = L["General"],
			order = 1,
			args = {
				report = {
					type = "select",
					name = L["Reporting"],
					desc = L["Where to output reports?"],
					values = {["SAY"]=L["Say"], ["RAID"]=L["Raid"], ["RAID_WARNING"]=L["Raid warning"], ["PARTY"]=L["Party"], ["GUILD"]=L["Guild"], ["OFFICER"]=L["Officer"], ["CHANNEL"]="Custom Channel"},
					get = function(info) return ENStats.db.global.output end,
					set = function(info, v)
						ENStats.db.global.output = v
						if v == "CHANNEL" then ENStats.options.args.general.args.channel.disabled = false else ENStats.options.args.general.args.channel.disabled = true end
					end,
					order = 3,
				},	
				channel = {
					type = "input",
					name = "Channel number",
					disabled = true,
					desc = "Enter a chat channel's number here",
					get = function(info) return ENStats.db.global.channel end,
					set = function(info, v)
						ENStats.db.global.channel = v
					end,
					order = 4,
				},	
				annoreport = {
					type = "select",
					name = L["Announce"],
					desc = L["Where to output announcements?"],
					disabled = true,
					values = {["SAY"]=L["Say"], ["RAID"]=L["Raid"], ["RAID_WARNING"]=L["Raid warning"], ["PARTY"]=L["Party"], ["GUILD"]=L["Guild"], ["OFFICER"]=L["Officer"], ["CHANNEL"]="Custom Channel"},
					get = function(info) return ENStats.db.global.annooutput end,
					set = function(info, v)
						ENStats.db.global.annooutput = v
						if v == "CHANNEL" then ENStats.options.args.general.args.annochannel.disabled = false else ENStats.options.args.general.args.annochannel.disabled = true end
					end,
					order = 1,
				},	
				annochannel = {
					type = "input",
					name = "Channel number",
					disabled = true,
					desc = "Enter a chat channel's number here",
					get = function(info) return ENStats.db.global.annochannel end,
					set = function(info, v)
						ENStats.db.global.annochannel = v
					end,
					order = 5,
				},	
				MinimapIcon = {
					type = "toggle",
					name = "Minimap button",
					desc = " ",
					order = 7,
					get = function() return not ENStats.db.global.MiniMap.hide end,
					set = function()
						ENStats.db.global.MiniMap.hide = not ENStats.db.global.MiniMap.hide
						ENStats:ToggleMM(ENStats.db.global.MiniMap.hide)
					end,
					hidden = function() return IsAddOnLoaded("FuBar") end,
				},	
				anno = {
					type = "toggle",
					name = L["Announce failures"],
					desc = " ",
					order = 6,
					get = function() return ENStats.db.global.anno end,
					set = function()
						ENStats.db.global.anno = not ENStats.db.global.anno
						if ENStats.db.global.anno then 
							ENStats.options.args.general.args.annoreport.disabled = false
							if ENStats.db.global.annooutput == "CHANNEL" then ENStats.options.args.general.args.annochannel.disabled = false else ENStats.options.args.general.args.annochannel.disabled = true end 
						else 
							ENStats.options.args.general.args.annoreport.disabled = true
							ENStats.options.args.general.args.annochannel.disabled = true 
						end																		
					end,
				},
			},
		},	
		FuBar = {
			order = 110,
			inline = true,
			type = "group",
			name = L["FuBar Options"],
			desc = L["FuBar Options"],
			hidden = function() return not IsAddOnLoaded("FuBar") end,
			args = {		
				showIcon = {
					type = "toggle",
					order = 3,
					name = L["Show icon"],
					desc = L["Show icon"],
					get = function(info) return ENStats:IsFuBarIconShown() end,
					set = function(info, v) ENStats:ToggleFuBarIconShown() end,
				},
				showText = {
					type = "toggle",
					order = 4,
					name = L["Show text"],
					desc = L["Show text"],
					get = function(info) return ENStats:IsFuBarTextShown() end,
					set = function(info, v) ENStats:ToggleFuBarTextShown() end,					
				},
				pos = {
					type = "select",
					name = "Position",
					desc = "Position",
					values = {["LEFT"]="Left", ["RIGHT"]="Right", ["CENTER"]="Center"},
					get = function(info) return ENStats:GetPanel():GetPluginSide(ENStats) end,
					set = function(info, v)
						if ENStats:GetPanel() and ENStats:GetPanel().SetPluginSide then
							ENStats:GetPanel():SetPluginSide(ENStats, v)
						end
					end,
				},					
			},
		},
		Appearance = {
			type = "group",
			inline = true,
			name = L["Appearance"],
			order = 2,
			args = {		
				test = { 
					type = 'execute',
					name = "Test Mode",
					desc = L["Fills in some test data."],
					func = function() ENStats:OnCmd("test") end,					
					order = 1, 
				},						 
				height = { 
					type = 'range',
					name = L["Bar height"],
					desc = L["Changes the height of the bars."],
					min = 6,
					max = 25,
					step = 1,
					get = function() return ENStats.db.global.height end,
					set = function(info, v) ENStats.db.global.height = v;
						local count = 0 
						for i=1,#ENStats.bars do
							ENStats.bars[i]:SetHeight(v);
							ENStats.bars[i]:SetPoint("TOPLEFT",8,(i*-ENStats.db.global.height)+ENStats.db.global.height-7)
							if ENStats.bars[i]:IsVisible() then count=count+1 end
						end 
						ENStats.container:SetHeight((count*ENStats.db.global.height)+13)
						ENStats.MainFrame:SetVerticalScroll(ENStats.db.global.height) 
					end,
					order = 2, 
				},
				width = { 
					type = 'range',
					name = L["Bar width"],
					desc = L["Changes the width of the bars."],
					min = 230,
					max = 500,
					step = 1,
					get = function() return ENStats.db.global.width end,
					set = function(info, v) ENStats.db.global.width = v; 
						for i=1,#ENStats.bars do
							ENStats.bars[i]:SetWidth(v-16);							
						end 
						ENStats.MainFrame:SetWidth(v)
						ENStats.header:SetWidth(v) 
						ENStats.footer:SetWidth(v)
						ENStats.MainFrame:SetUserPlaced(true)
					end,
					order = 2, 
				},				
				fontsize = { 
					type = 'range',
					name = L["Font size"],
					desc = L["Changes the font size."],
					min = 6,
					max = 20,
					step = 1,
					get = function() return ENStats.db.global.fontsize end,
					set = function(info, v) ENStats.db.global.fontsize = v;
						for i=1,#ENStats.bars do
							ENStats.LeftText[i]:SetFont(media:Fetch("font",ENStats.db.global.font),v)													 
							ENStats.LeftText[i]:ClearAllPoints(); 
							ENStats.LeftText[i]:SetPoint("LEFT", ENStats.bars[i], 4, 0);
							ENStats.RightText[i]:SetFont(media:Fetch("font",ENStats.db.global.font),v)													 
							ENStats.RightText[i]:ClearAllPoints(); 
							ENStats.RightText[i]:SetPoint("RIGHT", ENStats.bars[i], -4, 0);													 
						end											 
					end, 
					order = 7, 
				},											 											 	
				colorbg = { 
					type = 'color',
					name = L["Background color"],
					desc = L["Changes background color and opacity."],
					hasAlpha = true,
					get = function(info) return ENStats.db.global.colorbg.r, ENStats.db.global.colorbg.g, ENStats.db.global.colorbg.b, ENStats.db.global.colorbg.a end,
					set = function(info, r, g, b, a)
						ENStats.MainFrame:SetBackdropColor(r, g, b, a)
						ENStats.header:SetBackdropColor(r, g, b, a)
						ENStats.footer:SetBackdropColor(r, g, b, a)
						ENStats.db.global.colorbg.r = r;
						ENStats.db.global.colorbg.g = g;
						ENStats.db.global.colorbg.b = b;
						ENStats.db.global.colorbg.a = a;
					end,
					order = 8, 
				},
				color = { 
					type = 'color',
					name = L["Bar color"],
					desc = L["Changes bar color and opacity."],
					hasAlpha = true,
					get = function(info) return ENStats.db.global.color.r, ENStats.db.global.color.g, ENStats.db.global.color.b, ENStats.db.global.color.a end,
					set = function(info, r, g, b, a)
						for i=1,#ENStats.bars do
							ENStats.bars[i]:SetStatusBarColor(r, g, b, a)
						end 			
						ENStats.db.global.color.r = r;
						ENStats.db.global.color.g = g;
						ENStats.db.global.color.b = b;
						ENStats.db.global.color.a = a;
					end,
					order = 9, 
				},
				texcolor = { 
					type = 'color',
					name = L["Font color"],
					desc = L["Changes font color and opacity."],
					hasAlpha = true,
					get = function(info) return ENStats.db.global.texcolor.r, ENStats.db.global.texcolor.g, ENStats.db.global.texcolor.b, ENStats.db.global.texcolor.a end,
					set = function(info, r, g, b, a)
						for i=1,#ENStats.bars do
							ENStats.LeftText[i]:SetTextColor(r,g,b,a)
							ENStats.RightText[i]:SetTextColor(r,g,b,a)																																			
						end
						ENStats.Titel:SetTextColor(r,g,b,a)																 
						ENStats.db.global.texcolor.r = r;
						ENStats.db.global.texcolor.g = g;
						ENStats.db.global.texcolor.b = b;
						ENStats.db.global.texcolor.a = a;
					end,
					order = 10, 
				},											 												 
				font = {
					type = "select",
					name = L["Font"],
					desc = L["Changes the font."],
					values = fonts,
					get = function(info) return GetLSMIndex("font", ENStats.db.global.font) end,
					set = function(info, v)
						ENStats.db.global.font = media:List("font")[v]
						for i=1,#ENStats.bars do
							ENStats.LeftText[i]:SetFont(media:Fetch("font",ENStats.db.global.font),ENStats.db.global.fontsize)
							ENStats.RightText[i]:SetFont(media:Fetch("font",ENStats.db.global.font),ENStats.db.global.fontsize)																																				
						end
					end,
					order = 11,
				},		
				bartex = {
					type = "select",
					name = L["Bar texture"],
					desc = L["Changes the bar texture."],
					values = textures,
					get = function(info) return GetLSMIndex("statusbar", ENStats.db.global.tex) end,
					set = function(info, v)
						ENStats.db.global.tex = media:List("statusbar")[v]
						for i=1,#ENStats.bars do
							ENStats.bars[i]:SetStatusBarTexture(media:Fetch("statusbar",ENStats.db.global.tex))
						end 
					end,
					order = 12,
				},	
				strata = {
					type = "select",
					name = "Frame Strata",
					desc = " ",
					values = {["TOOLTIP"] = "1. Tooltip", ["FULLSCREEN_DIALOG"] = "2. Fullscreen Dialog", ["FULLSCREEN"] = "3. Fullscreen", ["DIALOG"] = "4. Dialog", ["HIGH"] = "5. High", ["MEDIUM"] = "6. Medium", ["LOW"] = "7. Low", ["BACKGROUND"] = "8. Background"},
					get = function(info) return ENStats.db.global.strata end,
					set = function(info, v)
						ENStats.db.global.strata=v
						ENStats.MainFrame:SetFrameStrata(v)
					end,
					order = 14,
				},																					 
			},					 						 
		}
	} 
} 

-- Config Stuff
AceConfig = LibStub("AceConfigDialog-3.0")
LibStub("AceConfig-3.0"):RegisterOptionsTable("ENStats", ENStats.options, nil)
AceConfig:AddToBlizOptions("ENStats", "Endeavour's Noob Stats")